diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSiphon.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSiphon.java
new file mode 100644
index 000000000..5cf1c61ba
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSiphon.java
@@ -0,0 +1,95 @@
+package net.minecraft.client.render.particle;
+
+import net.minecraft.core.block.entity.TileEntityMesh;
+import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3d;
+
+/**
+ * A bubble caught in a mesh's siphon. Samples {@link TileEntityMesh#computeSiphonVelocity}
+ * every tick exactly like a siphoned item does
+ */
+public class ParticleSiphon extends Particle {
+    public enum Look {
+        BUBBLE,
+        SPLASH
+    }
+
+    private final @NotNull TilePos meshPos;
+    private final @NotNull Direction direction;
+    private final double wanderPhase;
+    private final double swirlJitter;
+    private final double pullJitter;
+    private final @NotNull Vector3d velocity = new Vector3d();
+
+    public ParticleSiphon(@NotNull World world, double x, double y, double z,
+                          @NotNull TilePos meshPos, @NotNull Direction direction,
+                          @NotNull Dimension dimension, @NotNull Look look) {
+        super(world, x, y, z, 0.0, 0.0, 0.0);
+
+        this.meshPos = meshPos;
+        this.direction = direction;
+
+        this.noPhysics = true;
+        this.gravity = 0.0f;
+
+        this.rCol = this.gCol = this.bCol = 1.0F;
+        if (look == Look.SPLASH) {
+            this.tex = (dimension == Dimension.NETHER ? ParticleTextureCache.ICON_SPLASH_RAIN_BLOOD : ParticleTextureCache.ICON_SPLASH_RAIN)[random.nextInt(4)];
+            this.size = this.size * (random.nextFloat() * 0.3F + 0.25F);
+        } else {
+            this.tex = dimension == Dimension.NETHER ? ParticleTextureCache.ICON_BUBBLE_BOILING : ParticleTextureCache.ICON_BUBBLE;
+            this.size = this.size * (random.nextFloat() * 0.4F + 0.2F);
+        }
+
+        this.wanderPhase = random.nextFloat() * Math.PI * 2.0;
+        this.swirlJitter = 0.8 + random.nextFloat() * 0.4;
+        this.pullJitter = 0.85 + random.nextFloat() * 0.3;
+
+        this.xd = this.yd = this.zd = 0.0;
+        this.lifetime = (int)((60 + random.nextInt(40)) / TileEntityMesh.SIPHON_SPEED);
+    }
+
+    @Override
+    public void tick() {
+        this.cachedLightmapCoord = calcLightIndex(1f);
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+
+        double wander = Math.sin(this.age * 0.15 + this.wanderPhase) * 0.1;
+        TileEntityMesh.computeSiphonVelocity(this.meshPos, this.direction, this.x, this.y, this.z,
+            wander, this.swirlJitter, this.pullJitter, this.velocity);
+
+        this.xd = this.velocity.x;
+        this.yd = this.velocity.y;
+        this.zd = this.velocity.z;
+        this.move(this.xd, this.yd, this.zd);
+
+        this.age++;
+        if (this.lifetime-- <= 0) {
+            remove();
+            return;
+        }
+
+        double dx = (this.meshPos.x + 0.5) - this.x;
+        double dy = (this.meshPos.y + 0.5) - this.y;
+        double dz = (this.meshPos.z + 0.5) - this.z;
+        if (dx * dx + dy * dy + dz * dz < 0.35 * 0.35) {
+            remove();
+            return;
+        }
+
+        if (this.world.getBlockMaterial(Cache.queryPos.set(this.x, this.y, this.z)) != Materials.WATER) {
+            remove();
+        }
+    }
+
+    private static final class Cache {
+        private static final @NotNull TilePos queryPos = new TilePos();
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
index 2f7cb3cd8..ca38a8a69 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
@@ -164,6 +164,7 @@ public class GLRenderer {
         shader.uniformFloat("uLightMapStrength", instance.currentLightMapStrength);
         shader.uniformFloat("uAlphaTest", instance.currentAlphaTest);
         shader.uniformVec4f("uColor", Color.redFromInt(instance.currentColor)/255f, Color.greenFromInt(instance.currentColor)/255f, Color.blueFromInt(instance.currentColor)/255f, Color.alphaFromInt(instance.currentColor)/255f);
+        shader.uniformFloat("uCelestialAngle", (instance.mc.currentWorld != null ? instance.mc.currentWorld.getCelestialAngle(instance.mc.timer.partialTicks) : 0f));
         shader.uniformFloat("uCurrentTick", instance.mc.ticksRan + instance.mc.timer.partialTicks);
         shader.uniformFloat("uPartialTick", instance.mc.timer.partialTicks);
         shader.uniformFloat("frameTimeCounter", ShaderHelper.getFrameTimeCounter());
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBuffer.java b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBuffer.java
index c787d848f..137740ba5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBuffer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/framebuffer/FrameBuffer.java
@@ -22,6 +22,7 @@ public abstract class FrameBuffer {
     private final @NotNull Vector2ic size;
 
     private boolean deleted = false;
+    private boolean validated = false;
 
     protected FrameBuffer(final @NotNull FrameBufferAttachment @NotNull ... attachments) {
         if (attachments.length == 0) {
@@ -67,9 +68,12 @@ public abstract class FrameBuffer {
 
         this.id = GL41.glGenFramebuffers();
 
+        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, this.id);
         for (final @NotNull FrameBufferAttachment attachment : attachments) {
             attachment.attachToFramebuffer(this);
         }
+        this.checkComplete();
+        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
     }
 
     public @Nullable FrameBufferAttachment getAttachment(final @NotNull AttachmentType attachmentType) {
@@ -103,10 +107,6 @@ public abstract class FrameBuffer {
         return this.deleted;
     }
 
-    public boolean isComplete() {
-        return GL41.glCheckFramebufferStatus(this.id) == GL41.GL_FRAMEBUFFER_COMPLETE;
-    }
-
     private void checkComplete() {
         final int status = GL41.glCheckFramebufferStatus(GL41.GL_FRAMEBUFFER);
 
@@ -152,9 +152,9 @@ public abstract class FrameBuffer {
             throw new IllegalStateException("Frame buffer deleted!");
         }
 
-        this.whileBound(this::checkComplete);
-
         this.blitInner();
+
+        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
     }
 
     public final void bind() {
@@ -162,8 +162,6 @@ public abstract class FrameBuffer {
             throw new IllegalStateException("Frame buffer deleted!");
         }
 
-        this.whileBound(this::checkComplete);
-
         this.bindInner();
     }
 
@@ -174,8 +172,6 @@ public abstract class FrameBuffer {
             throw new IllegalStateException("Frame buffer deleted!");
         }
 
-        this.whileBound(this::checkComplete);
-
         GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java
index cff4b9765..66dc9ca31 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRenderer.java
@@ -16,8 +16,10 @@ public abstract class TerrainRenderer {
 	}
 	
 	public abstract void renderSolidTerrain(float partialTicks);
-	
+
 	public abstract void renderTranslucentTerrain(float partialTicks);
+
+	public void resetChunkSorting() { }
 	
 	public abstract @NotNull ChunkRenderer createChunkRenderer(
 		@NotNull World world,
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
index 0d09677e7..c46509529 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/TerrainRendererMultiDraw.java
@@ -43,6 +43,7 @@ public class TerrainRendererMultiDraw extends TerrainRenderer {
     private final @NotNull Vector3d renderPos = new Vector3d();
     private final @NotNull Vector3d prevSort = new Vector3d();
     private final @NotNull Vector3d d = new Vector3d();
+    private boolean forceResort = true;
 
     public TerrainRendererMultiDraw(final @NotNull Minecraft minecraft) {
         super(minecraft);
@@ -62,7 +63,8 @@ public class TerrainRendererMultiDraw extends TerrainRenderer {
 
         this.d.set(this.renderPos).sub(this.prevSort);
 
-        if (this.d.dot(this.d) > 64) {
+        if (this.forceResort || this.d.dot(this.d) > 64) {
+            this.forceResort = false;
             this.prevSort.set(this.renderPos);
 
             this.mc.renderGlobal.resortChunks(
@@ -189,6 +191,11 @@ public class TerrainRendererMultiDraw extends TerrainRenderer {
         return renderList;
     }
 
+    @Override
+    public void resetChunkSorting() {
+        this.forceResort = true;
+    }
+
     @Override
     public @NotNull ChunkRenderer createChunkRenderer(
         final @NotNull World world,
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
index f52c164ab..937819794 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
@@ -36,7 +36,7 @@ public class VertexBuffer {
         this.vbo = glGenBuffers();
         this.vao = GL41.glGenVertexArrays();
         glBindBuffer(GL_ARRAY_BUFFER, this.vbo);
-        glBufferData(GL_ARRAY_BUFFER, this.capacity, GL_DYNAMIC_DRAW);
+        glBufferData(GL_ARRAY_BUFFER, this.capacity, GL_STATIC_DRAW);
         glBindBuffer(GL_ARRAY_BUFFER, 0);
     }
 
@@ -139,7 +139,7 @@ public class VertexBuffer {
 
         final int newBuffer = glGenBuffers();
         glBindBuffer(GL_ARRAY_BUFFER, newBuffer);
-        glBufferData(GL_ARRAY_BUFFER, newCapacity, GL_DYNAMIC_DRAW);
+        glBufferData(GL_ARRAY_BUFFER, newCapacity, GL_STATIC_DRAW);
 
         OpenGLHelper.checkError("create expand buffer");
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 52f300e11..7678ac024 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -173,6 +173,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
     private static void drawTexturedModalRect(final double width, final double height, final boolean blended, final @NotNull IconCoordinate coordinate) {
         if (blended) {
             GLRenderer.globalSetLightEnabled(false);
+            GLRenderer.setLightMapStrength(0);
         }
         coordinate.parentAtlas.bind();
         final TessellatorGeneral tessellator = GLRenderer.getTessellator();
@@ -184,6 +185,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign> {
         tessellator.addVertexWithUV(width / 2, height / 2, 0, coordinate.getIconUMax(), coordinate.getIconVMin());
         tessellator.draw();
         GLRenderer.globalSetLightEnabled(true);
+        GLRenderer.setLightMapStrength(1);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
index c2507eac2..928f1b498 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
@@ -36,6 +36,9 @@ public class ItemDragHandler extends Gui {
 	protected ItemStack draggingItemStack;
 	protected final List<Slot> draggedSlots = new ArrayList<>();
 
+	protected int modDragButton = -1;
+	protected final List<Slot> modDraggedSlots = new ArrayList<>();
+
 	private int lastX = Integer.MAX_VALUE; private int lastY = Integer.MAX_VALUE;
 	private final ArrayList<Slot> dragOverBuffer = new ArrayList<>(2);
 
@@ -58,16 +61,22 @@ public class ItemDragHandler extends Gui {
         this.renderOffsetX = 0;
         this.renderOffsetY = 0;
 		
-		if(isDragging()) {
-			this.dragOverBuffer.clear();
-			if (Math.max(this.lastX, this.lastY) == Integer.MAX_VALUE) {
-				final var slot = this.container.getSlotAtPosition(mouseX, mouseY);
-				if (slot != null) this.dragOverBuffer.add(slot);
-			} else {
-				this.container.getSlotsBetweenPositions(this.lastX, this.lastY, mouseX, mouseY, this.dragOverBuffer);
+		if(isModDragging()) {
+			sweepSlotsSinceLastFrame(mouseX, mouseY);
+			for (final var slot : this.dragOverBuffer) {
+				if (this.modDraggedSlots.contains(slot)) {
+					continue;
+				}
+				this.modDraggedSlots.add(slot);
+				if (slot.hasItem()) {
+					this.container.clickSlot(slot, this.modDragButton);
+				}
 			}
-			this.lastX = mouseX;
-			this.lastY = mouseY;
+			return;
+		}
+
+		if(isDragging()) {
+			sweepSlotsSinceLastFrame(mouseX, mouseY);
 			if (this.dragOverBuffer.isEmpty()) this.onDragOutsideOfSlots();
 			else for (final var slot : this.dragOverBuffer) onDragOverSlot(slot);
 
@@ -98,7 +107,19 @@ public class ItemDragHandler extends Gui {
 			}
 		}
 	}
-	
+
+	private void sweepSlotsSinceLastFrame(int mouseX, int mouseY) {
+		this.dragOverBuffer.clear();
+		if (Math.max(this.lastX, this.lastY) == Integer.MAX_VALUE) {
+			final var slot = this.container.getSlotAtPosition(mouseX, mouseY);
+			if (slot != null) this.dragOverBuffer.add(slot);
+		} else {
+			this.container.getSlotsBetweenPositions(this.lastX, this.lastY, mouseX, mouseY, this.dragOverBuffer);
+		}
+		this.lastX = mouseX;
+		this.lastY = mouseY;
+	}
+
 	protected void onDragOverSlot(Slot slot) {
 		if(slot == null) return;
 		
@@ -156,11 +177,15 @@ public class ItemDragHandler extends Gui {
 		if(pressed) {
 			if(mod) {
                 this.cancelRelease.add(button);
+				startModDragging(x, y, slot, button);
                 this.container.clickInventory(x, y, button);
 			}else {
 				mousePressed(x, y, slot, button);
 			}
 		}else {
+			if(button == this.modDragButton) {
+				stopModDragging();
+			}
 			if(this.cancelRelease.contains(button)) {
                 this.cancelRelease.remove(button);
 				return;
@@ -169,6 +194,29 @@ public class ItemDragHandler extends Gui {
 		}
 
     }
+
+	private void startModDragging(final int x, final int y, final @Nullable Slot slot, int button) {
+		if(button != 0 && button != 1) {
+			return;
+		}
+        this.modDragButton = button;
+        this.modDraggedSlots.clear();
+		if(slot != null) {
+            this.modDraggedSlots.add(slot);
+		}
+		this.lastX = x;
+		this.lastY = y;
+	}
+
+	protected final void stopModDragging() {
+        this.modDragButton = -1;
+        this.modDraggedSlots.clear();
+		this.lastX = this.lastY = Integer.MAX_VALUE;
+	}
+
+	public boolean isModDragging() {
+		return this.modDragButton != -1;
+	}
 	
 	public void click(InventoryAction action, int[] args) {
         this.mc.playerController.handleInventoryMouseClick(this.container.inventorySlots.containerId, action, args, this.mc.thePlayer);
diff --git a/game/client/src/main/resources/shaders/clouds.fsh b/game/client/src/main/resources/shaders/clouds.fsh
index a482602c3..67f978238 100644
--- a/game/client/src/main/resources/shaders/clouds.fsh
+++ b/game/client/src/main/resources/shaders/clouds.fsh
@@ -26,15 +26,16 @@ layout (std140) uniform Matrices {
 uniform float uAlphaTest;
 uniform int isEyeInLiquid;
 uniform vec2 uViewPortSize;
+uniform vec4 uColor;
 
 uniform sampler2D colortex;
 uniform sampler2D lighttex;
 
 float distance() {
-	vec4 fragPos = matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0 - 1.0, gl_FragCoord.z * 2.0 - 1.0, 1.0);
+	vec4 fragPos = matrices.viewInv * matrices.projectionInv * vec4((gl_FragCoord.xy / uViewPortSize) * 2.0 - 1.0, gl_FragCoord.z * 2.0 - 1.0, 1.0);
 	fragPos /= fragPos.w;
 
-	return length(fragPos.xyz);
+	return length(fragPos.xz);
 }
 
 void main() {
@@ -50,7 +51,7 @@ void main() {
 		discard;
 	}
 	
-	vec4 col = Color;
+	vec4 col = Color * uColor;
 
 	float fogStrength = 0.0;
 
diff --git a/game/client/src/main/resources/shaders/clouds.vsh b/game/client/src/main/resources/shaders/clouds.vsh
index cb437bb97..04756272e 100644
--- a/game/client/src/main/resources/shaders/clouds.vsh
+++ b/game/client/src/main/resources/shaders/clouds.vsh
@@ -1,25 +1,40 @@
 #version 410 core
+
 layout (location = 0) in vec3 aPos;
 layout (location = 1) in vec4 aColor;
 layout (location = 2) in vec2 aUV;
-//layout (location = 3) in vec2 aLightmap;
-//layout (location = 4) in vec3 aNormal;
 
 out vec4 Color;
 out vec2 TexCoord;
 
-uniform mat4 model;
+uniform float xOffset;
+uniform float zOffset;
 
 layout (std140) uniform Matrices {
-	mat4 projection;
-	mat4 projectionInv;
-	mat4 view;
-	mat4 viewInv;
+    mat4 projection;
+    mat4 projectionInv;
+    mat4 view;
+    mat4 viewInv;
 } matrices;
 
+uniform mat4 model;
+
 void main() {
-	TexCoord = aUV;
-	Color = aColor;
+    Color = aColor;
+
+    float xInt = floor(xOffset);
+    float zInt = floor(zOffset);
+    float xFrac = fract(xOffset);
+    float zFrac = fract(zOffset);
+
+    TexCoord = aUV + vec2(
+        xInt * 1/256f,
+        zInt * 1/256f
+    );
+
+    vec3 pos = aPos;
+    pos.x -= xFrac;
+    pos.z -= zFrac;
 
-	gl_Position = matrices.projection * matrices.view * model * vec4(aPos, 1);
-}
\ No newline at end of file
+    gl_Position = matrices.projection * matrices.view * model * vec4(pos, 1.0);
+}
diff --git a/game/core/src/main/java/net/minecraft/core/InventoryAction.java b/game/core/src/main/java/net/minecraft/core/InventoryAction.java
index 217dc78f6..65d757ad6 100644
--- a/game/core/src/main/java/net/minecraft/core/InventoryAction.java
+++ b/game/core/src/main/java/net/minecraft/core/InventoryAction.java
@@ -78,19 +78,23 @@ public enum InventoryAction {
 		setId(CREATIVE_GRAB, 13);
 		setId(CREATIVE_MOVE, 14);
 		setId(CREATIVE_DELETE, 15);
-		setId(CREATIVE_DRAG, 20);
 
 		setId(INTERACT_SLOT, 16);
 		setId(INTERACT_GRABBED, 17);
-		
+
 		setId(EQUIP_ARMOR, 18);
 
 		setId(SORT, 19);
 
 		setId(LOCK, 20);
+
+		setId(CREATIVE_DRAG, 21);
 	}
-	
+
 	private static void setId(InventoryAction action, int id) {
+		if(actions[id] != null) {
+			throw new IllegalStateException("Inventory action id " + id + " is already used by " + actions[id] + ", cannot also assign it to " + action + "!");
+		}
 		actions[id] = action;
 		action.id = id;
 	}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
index 8c1af0d91..df602716e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
@@ -72,6 +72,7 @@ public class BlockLogicConduit extends BlockLogic
     private static final int CONNECT_LEVER = pc++;
     private static final int CONNECT_TORCH = pc++;
     private static final int CONNECT_REDSTONE_LANTERN = pc++;
+    private static final int CONNECT_REDSTONE_ORE = pc++;
     private static final int CONNECT_REDSTONE_BLOCK = pc++;
     private static final int CONNECT_MOTION_SENSOR = pc++;
     private static final int CONNECT_MATCHER = pc++;
@@ -426,6 +427,10 @@ public class BlockLogicConduit extends BlockLogic
                         }
                     }
                 }
+
+                if (nBlockType.isEmittingSignal(world1, nTilePos, side)) {
+                    return PROPAGATION_LENGTH;
+                }
             } else {
                 if (nBlockType == Blocks.PUMPKIN_REDSTONE) {
                     Side pumpkinFace = Side.fromId(world1.getBlockData(nTilePos));
@@ -584,6 +589,9 @@ public class BlockLogicConduit extends BlockLogic
         if (nBlock == Blocks.BLOCK_REDSTONE) {
             return CONNECT_REDSTONE_BLOCK;
         }
+        if (logic instanceof BlockLogicOreRedstone) {
+            return CONNECT_REDSTONE_ORE;
+        }
         if (logic instanceof BlockLogicRepeater) {
             Side axis = BlockLogicRepeater.getSideFromMeta(nData);
             return (side == axis || side == axis.opposite()) ? CONNECT_REPEATER : CONNECT_NONE;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
index e413fb88e..5b7288751 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMesh.java
@@ -4,10 +4,14 @@ import net.minecraft.core.block.entity.TileEntityMesh;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
+import java.util.Random;
+
 public class BlockLogicMesh extends BlockLogicTransparent
 {
 
@@ -23,6 +27,16 @@ public class BlockLogicMesh extends BlockLogicTransparent
         return false;
     }
 
+    @Override
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+        if (!(world.getTileEntity(tilePos) instanceof TileEntityMesh mesh)) return;
+
+        Direction direction = mesh.getSiphonDirection();
+        if (direction == null) return;
+
+        world.playBlockEvent(tilePos, LevelListener.EVENT_MESH_SIPHON_PARTICLES, direction.id);
+    }
+
     @Override
     public boolean collidesWithEntity(@NotNull Entity entity, @NotNull World world, @NotNull TilePosc tilePos) {
         return !(entity instanceof EntityItem);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
index 3b136a987..6b542f61f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
@@ -159,7 +159,7 @@ public class BlockLogicStatue extends BlockLogic implements BlockLogic.MatcherEn
 
     @Override
     public boolean pushesEntities(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Class<? extends Entity> entityClass) {
-        return true;
+        return false;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index c78a3e4f8..2ec2342a0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -468,9 +468,6 @@ public final class Blocks {
     public static final @NotNull Block<?> LOG_PALM = register("log.palm", "minecraft:block/log_palm", 287, BlockLogicLog::new)
         .withSound(BlockSounds.WOOD).withHardness(2.0F)
         .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
-    public static final @NotNull Block<?> LOG_PETRIFIED = register("log.petrified", "minecraft:block/log_petrified", 288, b -> new BlockLogicAxisAligned(b, Materials.STONE))
-            .withSound(BlockSounds.STONE).withHardness(8.0F)
-            .withTags(BlockTags.FENCES_CONNECT, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final @NotNull Block<?> LEAVES_OAK = register("leaves.oak", "minecraft:block/leaves_oak", 290, BlockLogicLeavesOak::new)
         .withSound(BlockSounds.GRASS).withHardness(0.2F).withLightBlock(1)
